Package ec.rule.breed

# Class RuleMutationPipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.rule.breed.RuleMutationPipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class RuleMutationPipeline extends BreedingPipeline
RuleMutationPipeline is a BreedingPipeline which implements a simple default Mutation for RuleIndividuals. Normally it takes an individual and returns a mutated child individual. RuleMutationPipeline works by calling mutateRules(...) on each RuleSet in the parent individual.

Typical Number of Individuals Produced Per `produce(...)` call
1

Number of Sources
1

Default Base
rule.mutate (not that it matters)

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `INDS_PRODUCED`
  `static final int`
  `NUM_SOURCES`
  `static final String`
  `P_MUTATION`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RuleMutationPipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `numSources()`
  Returns 1
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `int`
  `typicalIndsProduced()`
  Returns 1

  ### Methods inherited from class ec.BreedingPipeline

  `clone, fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, prepareToProduce, produces, setup, sourcesAreProperForm`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_MUTATION

    public static final String P_MUTATION
    See Also:
      - Constant Field Values

  - ### INDS_PRODUCED

    public static final int INDS_PRODUCED
    See Also:
      - Constant Field Values

  - ### NUM_SOURCES

    public static final int NUM_SOURCES
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### RuleMutationPipeline

    public RuleMutationPipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Returns 1
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### typicalIndsProduced

    public int typicalIndsProduced()
    Returns 1
    Overrides:
      `typicalIndsProduced` in class `BreedingPipeline`

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`